// CRActionPlanner.cpp: CRActionPlanner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "CRActionPlanner.h"
#include <Graphics/GRRender.h>

#ifdef USE_VHCHECKDLG
 #include "../../../Experiments/VH/VHInteraction/VHCheckDialog.h"
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
namespace Spr{;

//////////////////// ڐGNX ////////////////////
void CRActionPlanner::ContactInfo::SetContactInfo(int vh, int user, int c, float t){
	soVHIndex = vh;
	soUserIndex = user;
	firstCount = lastCount = c;
	firstTime = t;
}

int CRActionPlanner::ContactInfo::CheckContactType(int vh, int user){
	// ʂ̐ڐG
	int type = 0;

	if(user == 6 || user == 9){
		// [U̍Uqbg
		if(vh == 2 || vh == 3) type = 1;
		// [U̍UK[h
		if(vh == 5 || vh == 6 || vh == 8 || vh == 9) type = 3;
	}
	if(vh == 6 || vh == 9){
		// VH ̍Uqbg
		if(user == 2 || user == 3) type = 2;
		// VH ̍UK[h
		if(user == 5 || user == 8) type = 4;
	}

	return type;
}

//////////////////// \sNX ////////////////////
CRActionPlanner::CRActionPlanner(){
	bPlanner    = false;
	bPrediction = false;
	bLoadReal   = false;
	bLoadTemp   = false;
	times     = 0;
	startTime = 0;
}
	
void CRActionPlanner::SaveState(SGScene* scene, bool type){
	if(type){
		stateReal.clear();
		scene->SaveState(stateReal);	// type == 1 ݂̎͌̏ԂƂĕۑ
		bLoadReal = true;
	}
	else{
		stateTemp.clear();
		scene->SaveState(stateTemp);	// type == 0 ͓̎̏ԂƂĕۑ
		bLoadTemp = true;
	}
}

void CRActionPlanner::LoadState(SGScene* scene, bool type){
	if(type){
		if(bLoadReal){
			scene->LoadState(stateReal);	// type == 1 ݂̎͌̏Ԃǂݍ
			stateReal.clear();
		}
	}
	else{
		if(bLoadTemp){
			scene->LoadState(stateTemp);	// type == 0 ͓̎̏Ԃǂݍ
			stateTemp.clear();
		}
	}
}

void CRActionPlanner::Step(CRPuppet* puppet, CRUser* user, SGScene* scene){
	if(puppet->IsLoaded() && user->IsLoaded()){
		user->locus.SaveLog(user);
		if(bPlanner){
			Spr::GRRender* render;
			scene->GetRenderers().Find(render);
			if(bPrediction){
				//user->locus.SetLocusCoefficient(user, scene);
				PredictionAction(puppet, user, scene);
				//for(int i = 0; i < 2; ++i) if(user->locus.bPrediction[i]) user->locus.DrawFutureLocus(user->locus.ak[i], 10, 10, render, Vec4f(0,0,1,1));
			}
			else{
				user->locus.SetLocusCoefficient(user, scene);
				if(CheckPredictionStart(puppet, user, scene)){
					DSTR << "\Jn: " << scene->GetCount() * scene->GetTimeStep() << std::endl;
					bPrediction = true;
					times = 0;
				}
			}
			if(cPos.norm() > 0){
				// ڐG\zʒu\
				render->SetModelMatrix(Affinef());
				render->SetLineWidth(20);
				render->SetMaterial(GRMaterialData(Vec4f(1,0,0,1)));
				Vec3f pos = cPos;
				render->DrawDirect(GRRender::POINTS, &pos, &pos+1);
			}
		}
	}
}

void CRActionPlanner::PredictionAction(CRPuppet* puppet, CRUser* user, SGScene* scene){
	const int SETCOUNT =  20;

	if(times >= SETCOUNT){
		contactInfo.clear();
		bPrediction = false;
		// B^̏
		for(int i = 0; i < 3; ++i){
			puppet->rm2[i].Init();
			user->rm2[i].Init();
		}
		DSTR << "Ԑ؂: " << scene-> GetTimeStep() * scene->GetCount() << "\n" << std::endl;
		cPos = Vec3f();
		return;
	}

	if(ChooseTargetAction(puppet, user)){
		contactInfo.clear();
		bPrediction = false;
		// B^̏
		for(int i = 0; i < 3; ++i){
			puppet->rm2[i].Init();
			user->rm2[i].Init();
		}
		DSTR << "\zڐGʒu: " << cPos << std::endl;
		DSTR << "\: " << scene-> GetTimeStep() * scene->GetCount() << "\n" << std::endl;
		return;
	}

	currentTime = scene->GetCount() * scene->GetTimeStep();	// ݂̎
	SaveState(scene, 1);		// ݂̏Ԃۑ
	if(times == 0){
		SaveState(scene, 0);	// Ԃۑ
		contactInfo.clear();
		startTime = currentTime;

		// B^̃Rs[
		for(int i = 0; i < 3; ++i){
			puppet->rm2[i] = puppet->rm[i];
			user->rm2[i]   = user->rm[i];
		}
	}

	MovementPrediction(puppet, user, scene, times);

	LoadState(scene, 1);		// ݂̏Ԃǂݍ

	times++;
}

void CRActionPlanner::MovementPrediction(CRPuppet* puppet, CRUser* user, SGScene* scene, int count){
	const int STEPCOUNT = 2;
	const float RATE = 1.5f;
	
	LoadState(scene, 0);	// rԂĊJ
	float dt = scene->GetTimeStep();
	scene->SetTimeStep(dt * RATE);

	for(int i = 0; i < STEPCOUNT; i++){
		PredictionStep(puppet, user, scene, count * STEPCOUNT + i);
		ContactTest(puppet, user, scene, count * STEPCOUNT + i);
	}

	// XVʂ`
	GRRender* render;
	scene->GetRenderers().Find(render);
#ifdef USE_VHCHECKDLG
	vhCheckDialog->DrawTest(render, scene);
#endif
	scene->SetTimeStep(dt);
	SaveState(scene, 0);	// rԂۑ
}

void CRActionPlanner::PredictionStep(CRPuppet* puppet, CRUser* user, SGScene* scene, int count){
	float dt = scene->GetTimeStep();

	scene->ClearForce();
	scene->GenerateForce();
	
	//puppet->SetExpectedPos(dt);
	puppet->SetSpringForce(dt);
	user->SetExpectedPos(3 * count, dt);
	user->SetSpringForce(dt);


	for(int i = 0; i < 3; ++i){
		puppet->rm2[i].Step(scene);
		//user->rm2[i].Step(scene);
	}
	
	scene->Integrate();
}

bool CRActionPlanner::IsFirstContact(int vh, int user, int count){
	for(int i = 0; i < contactInfo.size(); ++i){
		if(contactInfo[i].soVHIndex == vh && contactInfo[i].soUserIndex == user){
			// OڐGĂ
			if(contactInfo[i].lastCount == count - 1){
				contactInfo[i].lastCount = count;
				return false;
			}
		}
	}
	return true;
}

void CRActionPlanner::ContactTest(CRHuman* human1, CRHuman* human2, SGScene* scene, int step){
	ContactInfo cInfo;
	for(int i = 0; i < human1->solids.size(); ++i){
		if(human1->solids[i]){
			for(int j = 0; j < human2->solids.size(); ++j){
				if(human2->solids[j]){
					// Q̍̂̐ڐG
					if(ContactCheckOfSolidPair(human1->solids[i], human2->solids[j], scene)){
						// OڐGĂ
						if(IsFirstContact(i, j, step)){
							int type = cInfo.CheckContactType(i,j);
							if(type != 0){
								float time = startTime + step * scene->GetTimeStep();
								cInfo.SetContactInfo(i, j, step, time);
								SetContactPointOfSolidPair(human1->solids[i], human2->solids[j], scene, cInfo.contactPoint);
								cInfo.soVH   = human1->solids[i];
								cInfo.soUser = human2->solids[j];
								cInfo.contactType = type;
								// ڐGo^
								contactInfo.push_back(cInfo);
							}
						}
					}
				}
			}
		}
	}
}

void CRActionPlanner::SetContactPointOfSolidPair(PHSolid* so1, PHSolid* so2, SGScene* scene, Vec3f* pos){
	CDCollisionEngine* ce = NULL;
	CDFramePair* fp = NULL;
	scene->GetBehaviors().Find(ce);
	fp = ce->GetFramePair(so1->GetFrame(), so2->GetFrame());
	if(fp->intersections.size() > 0){
		pos[0] = fp->intersections.begin()->convexPair->commonPoint;		// O[oWn
		pos[1] = fp->intersections.begin()->convexPair->closestPoint[0];	// soVH Wn
		pos[2] = fp->intersections.begin()->convexPair->closestPoint[1];	// soUser Wn
	}
}

Vec3f CRActionPlanner::ContactPointOfSolidPair(PHSolid* so1, PHSolid* so2, SGScene* scene){
	CDCollisionEngine* ce = NULL;
	CDFramePair* fp = NULL;
	scene->GetBehaviors().Find(ce);
	fp = ce->GetFramePair(so1->GetFrame(), so2->GetFrame());
	if(fp->intersections.size() > 0){
		return fp->intersections.begin()->convexPair->commonPoint;
	}
	return Vec3f();
}

bool CRActionPlanner::ContactCheckOfSolidPair(PHSolid* so1, PHSolid* so2, SGScene* scene){
	if(so2 == NULL) return false;
	CDCollisionEngine* ce = NULL;
	CDFramePair* fp = NULL;

	scene->GetBehaviors().Find(ce);
	fp = ce->GetFramePair(so1->GetFrame(), so2->GetFrame());
	if(fp == NULL) fp = ce->GetFramePair(so2->GetFrame(), so1->GetFrame());

	//return (fp->intersections.size() > 0);
	return (fp->lastContactCount == scene->GetCount() - 1);
}

bool CRActionPlanner::ContactCheckOfSolid(PHSolid* so, CRHuman* human, SGScene* scene){
	if(so == NULL) return false;
	Vec3f rforce = Vec3f(0,0,0);
	for(int i = 0; i < human->solids.size(); ++i){
		if(ContactCheckOfSolidPair(so, human->solids[i], scene)) return true;
	}
	return false;
}

Vec3f CRActionPlanner::GetContactForceOfSolidPair(PHSolid* so1, PHSolid* so2, SGScene* scene){
	PHContactEngine* pce = NULL;
	PHContactEngine::FramePairRecord* fpr = NULL;
	Vec3f rforce = Vec3f(0,0,0);
	int sign = 1;
	if(so1 == NULL || so2 == NULL) return rforce;

	scene->GetBehaviors().Find(pce);
	fpr = pce->GetFramePairRecord(so1->GetFrame(), so2->GetFrame());
	if(fpr == NULL){
		fpr = pce->GetFramePairRecord(so2->GetFrame(), so1->GetFrame());
		sign = -1;
	}

	rforce  = fpr->GetReflexForce();
	rforce += fpr->GetFrictionForce();

	fpr->Clear();

	return sign * rforce;
}

Vec3f CRActionPlanner::GetContactForceOfSolid(PHSolid* so, CRHuman* human, SGScene* scene){
	Vec3f rforce = Vec3f(0,0,0);
	if(so == NULL) return rforce;
	for(int i = 0; i < human->solids.size(); ++i){
		rforce += GetContactForceOfSolidPair(human->solids[i], so, scene);
	}
	return rforce;
}

bool CRActionPlanner::ChooseTargetAction(CRPuppet* puppet, CRUser* user){
	int cType;
	ContactInfo* cInfo = NULL;

	for(int i = 0, count = contactInfo.size(); i < contactInfo.size(); ++i){
		cType = contactInfo[i].contactType;
		if(cType > 0 && cType < 2){
			cInfo = &contactInfo[i];
			count = contactInfo[i].firstCount;
			if(cType == 1) break;
		}
		if(count < contactInfo[i].firstCount) break;
	}

	if(cInfo){
		DSTR << "Contact Solid: " << cInfo->soVHIndex << std::endl;
		switch(cType){
		case 1:	// [U̍UɃqbgĂ܂ꍇ
			//DSTR << "OH! No! " << "ڐG܂Ŏc " <<  cInfo->firstTime - currentTime << std::endl;
			cPos = cInfo->contactPoint[0];
			if(cInfo->firstTime - currentTime < 0.05f){
				DSTR << "͂߂" << std::endl;
				//puppet->rm[0].Init();
				//puppet->rm[1].Init();
				//puppet->rm[2].Init();
				/*if(cInfo->soVHIndex == 3){
					puppet->rm[2].SetSpring(cInfo->soVH, Vec3f());
					Vec3f p = (cInfo->soVH->GetCenterPosition() - cInfo->contactPoint[0]).unit() * 0.05f + cInfo->soVH->GetCenterPosition();
					puppet->rm[2].SetTargetPos(p, Vec3f());
					puppet->rm[2].SetTimer(0.01f, 0.0f);
					puppet->rm[2].SetType(3);
					//DSTR << "͔I" << std::endl;
				}*/
				contactInfo.clear();
				return true;
			}
			// ̂̍s
			if(cInfo->soVHIndex == 3){
				if(puppet->rm[2].state == 0){
					puppet->rm[2].SetSpring(cInfo->soVH, Vec3f());
					Vec3f p = GetPointToAvoid(cInfo->soVH->GetFrame()->GetPosture() * cInfo->contactPoint[2], cInfo->contactPoint[0], puppet->rm[2].GetPos(), 0.3f);
					puppet->rm[2].SetTargetPos(p, Vec3f());
					puppet->rm[2].SetTimer(cInfo->firstTime - currentTime, 0.02f);
					puppet->rm[2].SetType(3);
					//DSTR << "͔I" << std::endl;
				}
				else if(puppet->rm[2].state == 3){
					//puppet->rm[2].Init();
				}
			}

			//else if(cInfo->soVHIndex == 2){
				// Er̍s
				if(puppet->rm[0].state == 1){
					puppet->rm[0].Init();
					//DSTR << "Er͋x߁I" << std::endl;
				}
				else if(puppet->rm[0].state == 0){
					puppet->rm[0].SetSpring(puppet->solids[5], Vec3f(0,-0.8 * puppet->GetSolidInfo(5).scale.Y(),0));
					Vec3f p = GetPointToGuard(cInfo->soVH->GetFrame()->GetPosture() * cInfo->contactPoint[2], cInfo->contactPoint[0], puppet->rm[0].GetPos());
					puppet->rm[0].SetTargetPos(p, Vec3f());
					puppet->rm[0].SetTimer((cInfo->firstTime - currentTime) * 0.5, (cInfo->firstTime - currentTime) * 0.5);
					puppet->rm[0].SetType(2);

					//DSTR << "Er͎I" << std::endl;
				}
				else if(puppet->rm[0].state == 2){
					//puppet->rm[0].SetTarget(cInfo->contactPoint[0], Vec3f());
					//DSTR << "Er͂̂܂܁I" << std::endl;
				}

				// r̍s
				if(puppet->rm[1].state == 1){
					puppet->rm[1].Init();
					//DSTR << "r͋x߁I" << std::endl;
				}
				else if(puppet->rm[1].state == 0){
					puppet->rm[1].SetSpring(puppet->solids[8], Vec3f(0,-0.8 * puppet->GetSolidInfo(8).scale.Y(),0));
					Vec3f p = GetPointToGuard(cInfo->soVH->GetFrame()->GetPosture() * cInfo->contactPoint[2], cInfo->contactPoint[0], puppet->rm[1].GetPos());
					puppet->rm[1].SetTargetPos(p, Vec3f());
					puppet->rm[1].SetTimer((cInfo->firstTime - currentTime) * 0.5, (cInfo->firstTime - currentTime) * 0.5);
					puppet->rm[1].SetType(2);

					//DSTR << "r͎I" << std::endl;
				}
				else if(puppet->rm[1].state == 2){
					//puppet->rm[1].SetTarget(cInfo->contactPoint[0], Vec3f());
					//DSTR << "r͂̂܂܁I" << std::endl;
				}
			//}

			contactInfo.clear();
			return true;
			break;

		//case 2:	// [Uւ̍Uqbgꍇ
		//	contactInfo.clear();
		//	DSTR << "Attack !" << std::endl;
		//	break;

		//case 3:	// [U̍UK[hꍇ
		//	break;

		default:	// ̑̏ꍇ
			//contactInfo.clear();
			//DSTR << "Normal !" << std::endl;
			break;
		}
		
		//DSTR << cInfo->soVH->GetName() << " collided with " << cInfo->soUser->GetName() << std::endl;
		//DSTR << "VH chooses " << gdm.type << " action." << std::endl;
		//contactInfo.clear();
		return false;
	}
	else{
		//contactInfo.clear();
		//times = 0;
		return false;
	}
}

Vec3f CRActionPlanner::GetNearestPoint(Vec3f a, Vec3f b, Vec3f c){
	// abœ_cƂ̍ŋߖT_Ԃ
	Vec3f p;
	float t;
	t = (b - a) * (c - a) / ((b - a).norm() * (b - a).norm());
	if(t < 0) t = 0;
	if(t > 1) t = 1;
	p = (b - a) * t + a;
	return p;
}

Vec3f CRActionPlanner::GetPointToAvoid(Vec3f a, Vec3f b, Vec3f c, float d){
	Vec3f p = GetNearestPoint(a, (b - a).unit() * 0.2f + b, c);
	Vec3f q = (c - p);
	q.y = 0.0f;
	if(q.Z() > 0) q.z = 0.0f;
	return d * q.unit() + p;
}

Vec3f CRActionPlanner::GetPointToGuard(Vec3f a, Vec3f b, Vec3f c){
	return GetNearestPoint(a, (b - a) * 0.4f + a, c);
}

bool CRActionPlanner::CheckDirection(Vec3f a, Vec3f b, Vec3f v){
	// _ a 瑬x v ̂̕ _ b ɌĂH
	bool bTarget = true;
	Vec3f ab = b - a;
	bTarget &= (v.norm() > 3.0f);
	bTarget &= ((ab.norm() * ab.norm()) / (ab * v) < 0.5f);
	bTarget &= (acos(ab.unit() * v.unit()) < M_PI/8);
	return bTarget;
}

bool CRActionPlanner::CheckPredictionStart(CRPuppet* puppet1, CRPuppet* puppet2, SGScene* scene){
	//\Jn邩`FbN
	bool bStart = false;
	for(int i = 0; i < 2; ++i){
		bool bTrigger = false;
		bTrigger |= CheckDirection(puppet2->locus.logPos[i][0], puppet1->GetCOG(), puppet2->locus.CalcFutureVelocity(puppet2->locus.ak[i], 0, scene->GetTimeStep()));
		bTrigger |= CheckDirection(puppet2->locus.logPos[i][0], puppet1->solids[2]->GetCenterPosition(), puppet2->locus.CalcFutureVelocity(puppet2->locus.ak[i], 0, scene->GetTimeStep()));
		bTrigger |= CheckDirection(puppet2->locus.logPos[i][0], puppet1->solids[3]->GetCenterPosition(), puppet2->locus.CalcFutureVelocity(puppet2->locus.ak[i], 0, scene->GetTimeStep()));
		puppet2->locus.bPrediction[i] = bTrigger;
		bStart |= bTrigger;
	}
	return bStart;
}

/*void CRActionPlanner::MakeVirtualSphere(SGScene* scene){
	float r = 0.05f;
	UTRef<PHSolid> solid;
	if (!solid) solid = new PHSolid;
	solid->SetMass(r*r*20);
	Matrix3f in = Matrix3f::Unit();
	in *= 0.4f* solid->GetMass() *r*r;
	solid->SetInertia(in);

	UTRef<SGFrame> frame = solid->GetFrame();
	UTRef<GRSphere> sphere;
	UTRef<CDSphere> csphere;
	if (frame){
		frame->FindObject(csphere);
		frame->FindObject(sphere);
		frame->Clear();
	}else{
		frame = new SGFrame;
		solid->SetFrame(frame);
	}
	CDCollisionEngine* ce;
	if (scene) scene->GetBehaviors().Find(ce);
	if (ce){
		SGFrame* frCol = ce->GetFrame(0);
		if (frCol && frCol->GetParent()) frCol->GetParent()->AddChildObject(frame, scene);
	}else{
		scene->GetWorld()->AddChildObject(frame, scene);
	}
	Affinef afSphere;
	afSphere.Pos() = Vec3f(0,2,0);
	frame->SetPosture(afSphere);

	if (!sphere){
		sphere = new GRSphere;
		UTRef<GRMaterial> mat = new GRMaterial;
		mat->diffuse = Vec4f(0, 0.1f, 1.0f, 1.0f);
		mat->specular= Vec4f(0, 0.1f, 1.0f, 1.0f);
		mat->ambient = Vec4f(0, 0.1f, 0.1f, 1.0f);
		mat->emissive= Vec4f(0, 0.1f, 0.1f, 1.0f);
		sphere->AddChildObject(mat, scene);
	}
	sphere->radius = r;
	sphere->slices = 16;
	sphere->stacks = 8;
	frame->AddChildObject(sphere, scene);
	GRRender* render;
	scene->GetRenderers().Find(render);
	render->InitTree(frame, scene);

	if (!csphere) csphere = new CDSphere;
	csphere->radius = r;
	csphere->pmaterial = new PHPhysicalMaterial;
	csphere->pmaterial->pMatData.reflexDamper = 0.1f;
	csphere->pmaterial->pMatData.reflexSpring = 1.0f;
	frame->AddChildObject(csphere, scene);
	frame->CalcBBox();

	PHSolidContainer* sc;
	scene->GetBehaviors().Find(sc);
	if (sc && !sc->solids.Find(solid)) sc->AddChildObject(solid, scene);

	solid->SetVelocity(Vec3f());
	solid->SetAngularVelocity(Vec3f());

	PHContactEngine* pce;
	scene->GetBehaviors().Find(pce);
	if (pce && !pce->solids.Find(solid)){
		pce->AddChildObject(solid, scene);
		pce->Init(scene);
	}
}*/

}

