// CRBalance.h: CRBalance NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#ifndef CRBALANCE_H
#define CRBALANCE_H

#include <Graphics/GRRender.h>
#include <Graphics/GRMaterial.h>
#include <SceneGraph/SGScene.h>
#include <SceneGraph/SGFrame.h>
#include <Physics/PHPenalty.h>
#include <Physics/PHForceField.h>
#include <Physics/PhSolid.h>
#include <Physics/PhJoint.h>
#include <Base/Affine.h>
#include <vector>

#include "CRSupportArea.h"

namespace Spr{;

class CRHuman;

// oXƂ邽߂̊{NX
class CRBalance{
public:
	CRBalance();
	virtual ~CRBalance();

	PHJointEngine*		jointEngine;		// ֐߃GW
	PHGravityEngine*	gravityEngine;		// PHGravityEngine

//protected:
public:
	Vec3f cogPos;					// VH̏dS̈ʒu
	Quaterniond targetPostureQ;		// ڕW̎p
	Quaterniond nowPostureQ;		// ݂̎p
	Vec3f targetTorque;				// ݂̎pڕW̎pɂ̂ɕKvȃgN
	Vec3f targetForce;
	Vec3f targetZmp;				// ڕWylo
	Vec3f targetAccel;				// dS̖ڕWx

	// ol,_pW
	Vec3f spring_noV;				// oXgÑolW
//	float spring_no;				// oXgÑolW
	float dampa_no;					// oXgÑ_pW
	float springCog_no;				// dS̈ɂ͂̃olW
	float dampaCog_no;				// dS̈ɂ͂̃_pW

public:
//---------@{C^tF[X@---------//
	void Step(SGScene* scene,CRHuman* crHuman);
	void Load(SGScene* scene,CRHuman* crHuman);
	virtual void OnKeyDown(UINT &nChar,CRHuman* crHuman);
	virtual void Draw(GRRender* render,CRSupportArea* supportArea);
	virtual void Init(SGScene* scene,CRHuman* crHuman);


//-----------------@@----------------//
	virtual void Measure(SGScene* scene,CRHuman* crHuman);		// oXɕKvȊ{IȂƂv
	virtual void ModifyBody(SGScene* scene,CRHuman* crHuman);	// ̂ɃgNoXƂ
	virtual void SetBalanceParameter(CRHuman* crHuman);			// oXƂ邽߂̖ڕW̃p[^ݒ

	virtual void CalcBalanceTorque(SGScene* scene,CRHuman* crHuman);	// oXƂ邽߂ɏdSɕKvȃgŇvZ
	virtual void CalcBalanceForce(SGScene* scene,CRHuman* crHuman);		// oXƂ邽߂ɏdSɕKvȗ͂̌vZ
	void CalcTargetZMP(SGScene* scene,CRHuman* crHuman);		// ڕWZMP̌vZ
	void ControlBody(CRHuman* crHuman);							// oX邽߂̐
	void DrawZMP(GRRender* render);								// ZMP̕`
	Vec3f GetTargetZMP(){return targetZmp;}						// ڕWZMP̎擾
	Vec3f GetTargetForce(){ return targetForce;}				// dSɂڕW̗͂擾
	Vec3f GetTargetTorque(){ return targetTorque;}				// oXƂ̂ɕKvȏdSɂgN擾
	Vec3f GetTargetAccel(){ return targetAccel;}				// dS̖ڕW̉x擾

	// ZMP̈ɂ邩Ď 
	bool ZmpIncludeCheck(CRSupportArea& supportArea);
	bool PosIncludeTriangle(Vec3f t_a, Vec3f t_b, Vec3f t_c, Vec3f zmp);

};

}		//	end namespace Spr
#endif // !defined(CRBALANCE_H)
