#ifndef FIDOCNODE_H
#define FIDOCNODE_H

#include "FIIterator.h"
#include "FITypeDesc.h"
#include <Base/BaseUtility.h>
#include <list>
#include <algorithm>

namespace Spr {;

///	̌^
typedef std::string FIString;
///	0̕
extern FIString zeroLengthString;
///	̔r
struct FIStringLess{
	bool operator() (const FIString& s1, const FIString& s2) const { return s1.compare(s2) < 0;}
};
///	̕\
inline std::ostream& operator << (std::ostream& os, FIString s){
	os << s.c_str();
	return os;
}




/*	DocNode̐݌vɂ
	D3D̏ꍇCf[^t@CDVRML̓XNvgD
	Ƃ΁CVRML̏ꍇCorientation  xoĂ悤 Transform m[h
	肦D
	X̏ꍇCԂŒŁCf[^ĂD

	XDocNodéCÕtB[h1̂ŁCC++̃NX11ɑΉD
	VRMLDocNode͕肦āC蓖D

	IFɂ̂͂悢̂H
	悢


	C^[^́Cm[h񂷂邯ǁCgݗČ^͂ǂ邩H
	X͑gݗČ^ɂȂ邱ƂD
	VMRL͒P^D
	X
		MeshFace{ int n; int vtx[]; }
		Mesh{ MeshFace face; MeshMaterialList{} }
	D
	DocNodeŏɂ́H
		Mesh{
			face -> {
				int n;
				int vtx[];
			}
			children -> MeshMatrialList{
			}
		}


	gݗČ^̒񂷂Ȃ瑮̒lƂāCm[h^ɂȂ΂ȂȂD
	m[h
	m[hChildrenɓĂ
	ƂH
*/

class FITypeDesc;
/**	t@Co̓m[hD
	V[Ott@C烍[hCt@CɃZ[uۂɁC
	t@C𒼐ڈ킸ɁChLgIuWFNgăZ[uE
	[hƁCt@C̈hLgIuWFNgɔC
	Ƃł̂ŁCZ[uE[h̃R[h炷ƂłD
	̃NX́ChLgIuWFNg\m[h̊{NX.

	hLgm[hł́ClƂāCm[h邱Ƃo悤ɂĂD
	qm[hƑl̗Ƀm[h邱Ƃ蓾D*/
class SPR_DLL FIDocNodeBase:public UTRefCount{
public:
	friend class FISaveScene;
	///	zfXgN^p
	virtual ~FIDocNodeBase(){}

	//@name	m[h̊{
	//@{
	///	̃m[h̖O̎擾
	virtual UTString GetName() const =0;
	///	̃m[h̖O̐ݒ
	virtual void SetName(UTString s)=0;
	/**	̃m[ȟ^̎擾.
		t@XɂāF
		̃m[h̃m[hւ̃t@XꍇC
		GetType()  "REF" ԂCGetName()͎QƐ̃m[hԂD*/
	virtual UTString GetType() const =0;
	/**	̃m[ȟ^̐ݒ.
		t@X̏ꍇ́C "REF"ݒ肷D*/
	virtual void SetType(UTString t){ assert(0); }
	///	^Lqq̐ݒ
	virtual void SetTypeDesc(FITypeDesc* desc){ assert(0); }
	bool IsReference() const { return GetType().compare("REF") == 0; }
	//@}
	
	//@name	؍\̑
	//@{
	///	em[h
	virtual FIDocNodeBase* GetParent()=0;
	///	qm[h̐
	virtual int NChildren() const =0;
	///	qm[h
	virtual FIDocNodeBase* GetChild(int i){ return Child(i); }
	///	qm[h(Const)
	virtual const FIDocNodeBase* GetChild(int i) const { return ((FIDocNodeBase*)this)->Child(i); }
	///	qm[h̒ǉ
	virtual void AddChild(FIDocNodeBase* n){ n->SetParent(this); }
	///	em[h̐ݒ
	virtual void SetParent(FIDocNodeBase*)=0;
	///	qm[hׂč폜
	virtual void ClearChildren()=0;
	//@}

	//@name	̑
	//@{
	/**	Sݒ */
	template <class T> bool SetWholeData(const T& t){ return SetWholeData(&t, sizeof(t)); }
	virtual bool SetWholeData(const void* data, size_t sz);
	///	Ŝ擾D
	template <class T> bool GetWholeData(T& t){ return GetWholeData(&t, sizeof(t)); }
	virtual bool GetWholeData(void* data, size_t sz);	
	
	///	w̃f[^̐ݒ
	template <class T> bool SetData(const T& t, FIString id, FIString type){ return FindAttr(id).SetData(t, type); }
	///	w̃f[^̐ݒ(z̈ꊇݒ)
	bool SetData(const void* data, size_t& dataSize, size_t elementSize, FIString id, FIString type){ return FindAttr(id).SetDataImp(data, dataSize, elementSize, id, type); }
	///	w̃f[^̎擾
	template <class T> bool GetData(T& t, FIString id){ return FindAttr(id).GetData(t); }
	///	w̃f[^̎擾
	bool GetData(void* data, size_t sz, FIString id){ return FindAttr(id).GetDataImp(data, sz); }
	//@}

	//@name	̎
	//@{
	///	݂̑ɐVm[hZbgD
	virtual FIDocNodeBase* SetNewNode(FIString id, FIString type)=0;
	
	///	擪̑lwC^[^擾
	virtual FIIterator FirstAttr() const =0;
	///	Ō̎̑lwC^[^擾
	virtual FIIterator LastAttr() const =0;
	///	C^[^Ōɗ true
	virtual bool IsLast(const FIIterator& it) const { return it == LastAttr(); }
	///	w̃m[hwC^[^擾
	virtual FIIterator FindAttr(FIString id, size_t pos=0) const =0;
	//@}

	///	m[h̃c[\
	virtual void Print(std::ostream& os, int indent=0) const;
	///	\
	virtual void PrintAttr(std::ostream& os, int indent=0) const;
	///	qm[h̃c[\
	virtual void PrintChildren(std::ostream& os, int indent=0) const;
protected:
	///	qm[hԂ֐̎
	virtual FIDocNodeBase* Child(int i) = 0;
};

///	hLgm[h̊{NXvector
class SPR_DLL FIDocNodes:public UTStack< UTRef<FIDocNodeBase> >{
public:
	virtual void Print(std::ostream& os, int indent=0) const;
};

///	hLgm[h
class SPR_DLL FIDocNode:public FIDocNodeBase, public UTTreeNode<FIDocNode>{
public:
	struct TData{
		typedef std::vector<char> container;
		FIString type;							///<	ľ^
		size_t elementSize;						///<	vf̃TCY
		container data;							///<	obt@
		TData(){ elementSize=0; }
		///	f[^Ōɒǉ
		void PushBack(const void* d){
			data.resize(data.size()+elementSize);
			container::iterator it = data.end()-elementSize;
			memcpy(&*it, d, elementSize);
		}
		///	Ō̃f[^폜
		void PopBack(){
			data.resize(data.size() - elementSize);
		}
		///	1vf̃TCY
		size_t ElementSize() const { return elementSize; }
		void ElementSize(size_t s){ elementSize = s; }
		///	f[^
		void Size(size_t n){ data.resize(n*elementSize); }
		size_t Size() const { return elementSize ? data.size()/elementSize : 0; }
		///	Sf[^̃oCg
		size_t DataSize(){ return data.size(); }
		///	nԖڂ̃f[^ւ̃|C^
		char* Data(size_t i){ return &*data.begin() + i*elementSize; }
		///	ŏ̃f[^ւ̃|C^
		char* Begin(){ return &*data.begin(); }
		///	ŏ̃f[^ւ̃|C^
		const char* Begin() const { return &*data.begin(); }
		///	ŏ̃f[^̎ւ̃|C^
		char* End(){ return &*data.end(); }
		///	ŏ̃f[^̎ւ̃|C^
		const char* End() const { return &*data.end(); }
		///	TCY̐ݒ
		void Resize(size_t s){ data.resize(s*elementSize); }
	};
	///	m[hoCif[^̔z
	struct TValue{
		///	m[hl(oCilꍇ͋)
		std::vector< UTRef<FIDocNode> > nodes;
		///	oCif[^
		TData data;
		///	m[h܂̓f[^̐D
		size_t Size() const {
			return nodes.size() ? nodes.size() : data.Size();
		}
	};
	struct TAttr: public TValue{
		UTString id;				///<	
		TAttr(){}
		TAttr(FIString i):id(i){}
		bool operator < (const TAttr& b) const { return id.compare(b.id) < 0; }
		bool operator == (const TAttr& b) const { return id.compare(b.id)==0; }
	};
	class TAttrs:public std::vector<TAttr>{
	public:
		typedef std::vector<TAttr> base;
		TAttrs(){}
		TAttrs(size_t sz, const TAttr a):base(sz,a){}
		iterator Find(FIString id) const;
	};
	class TIteratorImp:public FIIteratorImpBase{
	public:
		TAttrs::iterator it;	//	ւ̃|C^
		size_t pos;				//	ł̈ʒu
		FIDocNode* node;

		TIteratorImp(FIDocNode* n, TAttrs::const_iterator i, size_t p):node(n), it((TAttrs::iterator&)i), pos(p){}
		virtual FIIteratorImpBase* Clone() const { return new TIteratorImp(*this); }
		virtual void Next(){
			if (pos < it->Size()) { ++pos; }
			else {
				if (Validate()) ++pos;
			}
		}
		bool Equal(const FIIteratorImpBase* bBase) const {
			const TIteratorImp* a = this;
			const TIteratorImp* b = (TIteratorImp*) bBase;
			return a->it == b->it && a->node == b->node && a->pos == b->pos;			
		}
		bool Validate() const;
//		bool ValidateNode();
//		bool ValidateData();
		//@{	gւ̃ANZX
		///	id擾
		virtual FIString GetId() const;
		///	f[^̌^擾
		virtual FIString GetType() const;
		///	f[^1vf̃TCY擾
		virtual size_t GetElementSize() const;
		///	f[^̗vf擾
		virtual size_t GetNElement() const;
		///	f[^ݒ肷Dszɂ́CۂɃZbgTCYԂD
		virtual bool SetDataImp(const void* data, size_t& sz, size_t esz, FIString id, FIString type);
		///	f[^擾Dszɂ́CۂɓǂݏoTCYԂD
		virtual bool GetDataImp(void* data, size_t& sz);
		///	m[hݒ肷
		virtual bool SetNode(FIDocNodeBase* node);
		///	m[h擾
		virtual FIDocNodeBase* GetNode();
		//@}
	};

	///	{NX
	typedef UTTreeNode<FIDocNode> FITree;

public:
	TAttrs attrs;
	FIString name;
	FIString type;
public:
	///
	FIDocNode(){}
	///
	~FIDocNode(){}
	//@name	m[h̑
	//@{
	///	̃m[h̖O̎擾
	virtual UTString GetName() const { return name; }
	///	̃m[h̖O̐ݒ
	virtual void SetName(UTString s){ name = s; }
	///	̃m[ȟ^̂Ă
	virtual void SetType(FIString t);
	///	̃m[ȟ^̎擾
	virtual FIString GetType() const;
	//@}
	
	//@name	؍\̑
	//@{
	///	em[h
	virtual FIDocNodeBase* GetParent(){ return FITree::GetParent(); }
	///	qm[h̐
	virtual int NChildren() const { return (int)FITree::Children().size(); }
	///	em[h̐ݒ
	virtual void SetParent(FIDocNodeBase* n){ FITree::SetParent((FIDocNode*)n); }
	///	qm[hׂč폜
	virtual void ClearChildren(){ FITree::ClearChildren(); }
	///	qm[hԂ
	virtual FIDocNodeBase* Child(int i){ return FITree::Children()[i]; }
	//@}
	
	//@name	̑
	//@{	
	virtual FIDocNodeBase* SetNewNode(FIString id, FIString type);
	virtual FIIterator FirstAttr() const;
	virtual FIIterator LastAttr() const;
	virtual FIIterator FindAttr(FIString id, size_t pos=0) const;
	virtual bool IsLast(const FIIterator& it) const;
	//@}
};
}
#endif
