#ifndef PH_JOINT1D_H
#define PH_JOINT1D_H

#include "PHJoint.h"

namespace Spr{;

struct XJoint1D;

///	1Rx̊֐
class PHJoint1D:public PHJointBase{
public:
	SGOBJECTDEFABST(PHJoint1D);
	double minPosition;						///<	͈(ől)
	double maxPosition;						///<	͈(ŏl)
	double torque;							///<	gN
	double accel;							///<	֐߉x
	double position;						///<	ψ
	double velocity;						///<	x
	void AddTorque(double t){ torque+=t; }	///<	gNǉ
	void SetTorque(double t){ torque=t; }	///<	gNݒ
	double GetTorque(){ return torque; }	///<	gN擾
	double GetPosition(){ return position; }///<	֐ߊpx擾
	double GetVelocity(){ return velocity; }///<	֐ߑx擾
	virtual void Integrate(double dt);		///<	ϕ
	void CompArticulatedInertia(double dt);	///<	articulated inertia & ZA-force
	void CalcAccel(double dt);				///<	̃WCg̉xvZDڍׂ͊{NX̃RgQƁD

	///	֐߂̎Rx
	virtual int GetJointDof(){ return 1; }
	///	֐߈ʒu̎擾
	virtual double GetJointPosition(int i){ return position; }
	///	֐ߑx̎擾
	virtual double GetJointVelocity(int i){ return velocity; }
	///	֐߉x̎擾
	virtual double GetJointAccel(int i){ return accel; }
	///	֐߃gN̎擾
	virtual double GetJointTorque(int i){ return torque; }
	///	֐߃gN̐ݒ
	virtual void SetJointTorque(double v, int i){ torque = v; }
	///	֐߃gN
	virtual void AddJointTorque(double v, int i){ torque += v; }

	void SaveX(XJoint1D&) const;
	void LoadX(const XJoint1D&);
protected:
	SpVec6d			s;					///<	spatial joint axis in Fc coord.
	//	s܂ރLbVϐ
	SpVec6d			Ia_s;
	double			dot_s_Ia_s, dot_s_Z_plus_Ia_c;

	virtual void Reset();
	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
	
	virtual void ClearTorqueRecursive();
	virtual void LimitAngle(double& d){}
};

///	Ԋ֐
class PHJointHinge:public PHJoint1D{
public:
	SGOBJECTDEF(PHJointHinge);
	virtual void CompJointAxis();
	virtual void CompRelativePosition();
	virtual void CompRelativeVelocity();
	virtual void CompCoriolisAccel();
protected:
	virtual void LimitAngle(double& d){ LimitCycle(d); }
	void Integrate(double dt);
};
///	XCh֐
class PHJointSlider:public PHJoint1D{
public:
	SGOBJECTDEF(PHJointSlider);
	virtual void CompJointAxis();
	virtual void CompRelativePosition();
	virtual void CompRelativeVelocity();
	virtual void CompCoriolisAccel();
};

}

#endif