#ifndef PH_JOINTPID_H
#define PH_JOINTPID_H

#include <Physics/PHJoint1D.h>
#include <Physics/PHJointMulti.h>

namespace Spr{;

class PHJointPid:public SGBehaviorEngine{
protected:
	///	O̖ڕWl
	float lastGoal;
	///	ϕ
	float integratedError;
public:
	SGOBJECTDEF(PHJointPid);
	///	Ώۊ֐
	UTRef<PHJointBase> joint;
	///	Ώۂ̎
	int axis;
	///	ڕWl		Step()ĂԑOɐݒ肷D
	float goal;
	///	ڕW̑x	Step()ĂԑOɐݒ肷D
	float dGoal;
	///	PIĎW
	float proportional, differential, integral;
	///	ڕW̃^Cv 0:ʒu	1Fx
	int type;
	/// proportional,differential,integralɂgN(PID)
	float p_torque, d_torque, i_torque;

	/// p_torque, d_torque,i_torque̎擾
	float GetProportionalTorque(){ return p_torque; }
	float GetDifferentialTorque(){ return d_torque; }
	float GetIntegralTorque(){ return i_torque; }

	///	ڕWl,ڕW̑x	Step()ĂԑOɐݒ肷
	void SetPGoal(float p_goal){ goal = p_goal;}
	void SetDGoal(float d_goal){ dGoal = d_goal;}
	
	///	
	PHJointPid():type(0), proportional(0), differential(0), integral(0), goal(0), dGoal(FLT_MAX), lastGoal(0), integratedError(0), axis(0){}
	///
	static PHJointPid* Find(PHJoint1D* j, SGScene* scene);
	///	vCIeB
	virtual int GetPriority() const { return SGBP_FORCEGENERATOR; }
	///	V[NAƂ̏
	virtual void Clear(SGScene* s){ joint=NULL; }

	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
	///	PIDD
	void Step(SGScene* s);	

	///
	double GetJointTorque(){ return joint->GetJointTorque(axis); }

	size_t NReferenceObjects();
	SGObject* ReferenceObject(size_t i);
	bool AddChildObject(SGObject* o, SGScene* s);
	bool DelChildObject(SGObject* o, SGScene* s);
protected:
};

class PHJointBallPid:public SGBehaviorEngine{
protected:
	///	ÕS[
	Quaterniond lastGoal;
	///	ϕ
	Vec3f integratedError;
public:
	SGOBJECTDEF(PHJointBallPid);
	///	Ώۊ֐
	UTRef<PHJointBall> joint;
	///	ڕWl			Step()ĂԑOɐݒ肷D
	Quaternionf goal;
	///	ڕWl̔	Step()ĂԑOɐݒ肷Dݒ肵ȂĂǂD
	Vec3f dGoal;
	///	PIĎW
	float proportional, differential, integral;
	/// proportional,differential,integralɂgN(PID)
	Vec3f p_torque, d_torque, i_torque;

	/// p_torque, d_torque,i_torque̎擾
	Vec3f GetProportionalTorque(){ return p_torque; }
	Vec3f GetDifferentialTorque(){ return d_torque; }
	Vec3f GetIntegralTorque(){ return i_torque; }
	
	///	
	PHJointBallPid():proportional(0), differential(0), integral(0), dGoal(FLT_MAX,0,0){}
	///
	static PHJointBallPid* Find(PHJointBall* j, SGScene* scene);
	///	vCIeB
	virtual int GetPriority() const { return SGBP_FORCEGENERATOR; }
	///	V[NAƂ̏
	virtual void Clear(SGScene* s){ joint=NULL; }

	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
	///	PIDD
	void Step(SGScene* s);

	///
	Vec3f GetJointTorque(){ return joint->GetTorque(); }

	size_t NReferenceObjects();
	SGObject* ReferenceObject(size_t i);
	bool AddChildObject(SGObject* o, SGScene* s);
	bool DelChildObject(SGObject* o, SGScene* s);	
};


}

#endif