#ifndef SGSCENE_H
#define SGSCENE_H

#include "SGFrame.h"
#include "SGBehaviorEngine.h"
#include "SGRenderEngine.h"

namespace Spr {;


class SGScene;

class SGObjectNamesLess{
public:
	bool operator () (SGObject* o1, SGObject* o2) const {
		return strcmp(o1->GetName(), o2->GetName()) < 0;
	}
};
/**	OƃV[Ot̃IuWFNg̑Ή\
	OL[ɂZbgpӂCÖӐ̕ۏ؂ƃIuWFNg
	D	*/
class SGObjectNames:public std::set<UTRef<SGObject>, SGObjectNamesLess >{
public:
	typedef std::map<UTString, UTString> TNameMap;
	TNameMap nameMap;
	void Print(std::ostream& os) const;
	///	OIuWFNg擾
	SGObject* Find(UTString name) const {
		SGObject key;
		key.name = name;
		key.AddRef();
		const_iterator it = find(&key);
		key.DelRef();
		if (it != end()) return *it;
		return NULL;
	}
	std::pair<iterator, iterator> Range(UTString name){
		std::pair<iterator, iterator> rv;
		SGObject key;
		key.name = name;
		key.AddRef();
		rv.first = find(&key);
		key.DelRef();
		if (rv.first == end()){
			rv.second = end();
		}else{
			rv.second = rv.first;
			++rv.second;
			for(; rv.second!=end(); ++rv.second){
				if (rv.second == end()) break;
				if (name.compare(0, name.length(), (*rv.second)->GetName())!=0) break;
			}
		}
		return rv;
	}
	/**	IuWFNg̒ǉC
		ÔȂIuWFNg͒ǉłȂD̏ꍇ false ԂD
		ǉɐ trueD łɓo^Ăꍇ false ԂD
		OԂꍇ́CǉIuWFNg̖OύXD	*/
	bool Add(SGObject* obj);
	///	IuWFNg̍폜
	bool Del(SGObject* key){
		iterator it = find(key);
		if (it==end()) return false;
		erase(it);
		return true;
	}
	///	IuWFNg̍폜
	bool Del(UTString name){
		SGObject key;
		key.name = name;
		key.AddRef();
		iterator it = find(&key);
		key.DelRef();
		if (it==end()) return false;
		erase(it);
		return true;
	}
};
inline std::ostream& operator << (std::ostream& os, const SGObjectNames& ns){
	ns.Print(os); return os;
}

/**	V[Ot̃gbvm[hDE_D
	_ƃV[Ot̊֌W[߁C
	_ႤƃV[Ot͂̂܂܎gpłȂD
	V[Ot́CƂ΃_OpenGLȂCdisplayList
	Ă邵CD3DȂ ID3DXMeshĂD
	OpenGL̃V[OtD3Dɕϊ邽߂ɂ́CxDocument
	Z[uāCD3D`Ń[hȂ΂ȂȂD	*/
class SPR_DLL SGScene:public SGObject{
	SGOBJECTDEF(SGScene);
protected:
	///	OƃIuWFNg̑Ή\	
	SGObjectNames names;
	///	rwCrAGW
	SGBehaviorEngines behaviors;
	///	_OGW
	SGRenderEngines renderers;
	///	gbvt[
	UTRef<SGFrame> world;
	/// ϕXebv
	double timeStep;
	/// ϕ
	unsigned int count;
public:

	///	RXgN^
	SGScene();
	///	fXgN^
	~SGScene(){Clear();}
	///	rwCrAGW vector ԂD
	SGBehaviorEngines& GetBehaviors(){ return behaviors; }
	const SGBehaviorEngines& GetBehaviors() const { return behaviors; }
	///	_OGW vector ԂD
	SGEngines& GetRenderers(){
		return renderers;
	}

	///	gbvt[ԂD
	SGFrame* GetWorld(){ return world; }
	///	OIuWFNg擾
	SGObject* FindObject(UTString name){ return names.Find(name); }
	///	^ƖOIuWFNg擾
	template <class T> void FindObject(UTRef<T>& t, UTString name){
		T* p;
		FindObject(p, name);
		t = p;
	}
	template <class T> void FindObject(T*& t, UTString name){
		t = DCAST(T, FindObject(name));
	}
	typedef SGObjectNames::iterator SetIt;
	typedef std::pair<SetIt, SetIt> SetRange;
	SetRange RangeObject(UTString n){ return names.Range(n); }
	
	SGObjectNames::TNameMap& GetNameMap(){ return names.nameMap; }

	/// ϕXebvԂ
	double GetTimeStep()const{return timeStep;}
	/// ϕXebvݒ肷
	void SetTimeStep(double dt){timeStep = dt;}
	/// JEgԂ
	unsigned GetCount()const{return count;}
	/// JEgݒ肷
	void SetCount(unsigned c){count = c;}
	///	V[̎i߂ ClearForce(); GenerateForce(); Integrate(); Ɠ
	void Step();
	///	V[̎i߂i͂̃NAj
	void ClearForce();
	///	V[̎i߂i͂̐j
	void GenerateForce();
	///	V[̎i߂i͂ƑxϕāCxƈʒuXVj
	void Integrate();
	///	_O
	void Render();
	///	[hCQƂ̉IĂĂяo֐DeIuWFNgLoadedĂяoD
	void Loaded(SGScene* scene);
	///	V[ɂD
	void Clear();
	///	O\CQƂĂȂIuWFNg폜D
	void ClearName();
	///	fobOp
	void Print(std::ostream& os) const { names.Print(os); }
	///	LĂIuWFNg̐
	virtual size_t NChildObjects();
	///	LĂIuWFNg
	virtual SGObject* ChildObject(size_t i);
	///	qIuWFNg̒ǉ
	virtual bool AddChildObject(SGObject* o, SGScene* s);
	///	qIuWFNg̍폜
	virtual bool DelChildObject(SGObject* o, SGScene* s);
	///	qɂȂ肦IuWFNǧ^̔z
	virtual const UTTypeInfo** ChildCandidates();

	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
protected:
//	friend class SGFrame;
	friend class SGObject;
};

}
#endif
