#ifndef WXD3D_H
#define WXD3D_H

#include "../Base/WXComBase.h"
#include "../Base/WXError.h"
#include <WinBasis/WBWindowMan.h>
#include <Base/Affine.h>

#if SPR_DXVER==9	//	see WXComBase.h
# include <d3d9.h>
# define D3DVIEWPORT_SPR	D3DVIEWPORT9
# define D3DMATERIAL_SPR	D3DMATERIAL9
# define D3DLIGHT_SPR		D3DLIGHT9

#elif SPR_DXVER==8
# include <d3d8.h>
# define D3DVIEWPORT_SPR	D3DVIEWPORT8
# define D3DMATERIAL_SPR	D3DMATERIAL8
# define D3DLIGHT_SPR		D3DLIGHT8

#endif

#include <dxfile.h>
namespace Spr{;

///	Direct3DIuWFNg
class SPR_DLL WXD3D:public WXSINGLETONV(Direct3D){
	IUnknown* Create();
public:
	WXD3D();
};
class SPR_DLL WXD3DPresentParameters:public D3DPRESENT_PARAMETERS{
public:
	WXD3DPresentParameters();
	void Window(int adaptor=0, int width=0, int height=0);
	void Fullscreen(int adaptor=0);
};

///	Direct3DfoCXifBXvCA_v^ɑΉfoCXjD
class SPR_DLL WXD3DDevice:public WXINTFV(Direct3DDevice){
protected:
	bool bCanDraw;
	bool bFullscreen;
	bool bInit;
public:
	///	\̎w
	WXD3DPresentParameters presentParameters;
	///	tH[JXEBhE
	HWND hFocusWindow;
	///	EBhȄ
	WBWindowMan winMan;

	///	RXgN^	
	WXD3DDevice(){
		bInit = false;
		hFocusWindow=NULL;
		presentParameters.Window();
		bCanDraw = false;
		bFullscreen = false;
	}
	/**	foCX̍\z
		hw ̐eǂĂCԐẽm[hCtH[JXEBhEƂD
		foCXEBhEw肳ĂȂ΁ChwfoCXEBhEɂD	*/
	bool Create(HWND hw,
		UINT adapter=D3DADAPTER_DEFAULT, D3DDEVTYPE deviceType=D3DDEVTYPE_HAL,
		DWORD behaviorFlags=D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_FPU_PRESERVE);
	///	T[tF[XTCY̎擾
	Vec2f GetSurfaceSize();
	///	r[|[g̃TCY̎擾
	Vec2f GetViewportSize();
	///	 r[|[g̕ύXDKvȂResizeĂяoăT[tF[X傫D
	bool SetViewport(Vec2f sz, Vec2f pos=Vec2f(), float minZ=0.0f, float maxZ=1.0f);
	bool SetViewport(HWND hw);
	///	`̃TCY̕ύXDꍇCtrueԂD
	bool Resize(Vec2f size, HWND wnd=NULL);
	///	ʃNA
	bool Clear(DWORD Count, CONST D3DRECT* pRects, DWORD Flags, D3DCOLOR Color, float Z, DWORD Stencil);
	///	ʂɕ\
	bool Present(CONST RECT* pSourceRect=NULL, CONST RECT* pDestRect=NULL, HWND hDestWindowOverride=NULL, CONST RGNDATA* pDirtyRegion=NULL);

	
	///	 tXN[ǂ
	bool IsFullscreen(){ return bFullscreen; }
	///	tXN[
	void Fullscreen();
	///	EBhE
	void Window();
	///	`ł邩ǂ
	bool CanDraw(){ return bCanDraw; }
	///	`Jn
	void BeginScene();
	///	`I
	void EndScene();
};

///	DirectXFileIuWFNg
class SPR_DLL WXDXFile: public WXSingletonInterface<IDirectXFile, &IID_IDirectXFile>{
	IUnknown* Create();
public:
	WXDXFile();
};

}

#endif
