#ifndef Spr_DDRAW_DDRAW_H
#define Spr_DDRAW_DDRAW_H
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "WXDDMode.h"
#include "WXDDFSurf.h" 
#include <WinDX/Base/WXComBase.h>
#include <WinDX/Base/WXError.h>
#include <WinBasis/WBCriticalSection.h>

#ifdef MULTITHREAD
 #define AUTOLOCK WXDDAutoLock autoLock;
#else
 #define AUTOLOCK
#endif

struct IDirect3D;
struct IDirect3D2;
struct IDirect3D7;

namespace Spr {;
class WXDDrawError;
class WXDDraw;
class WXDDraws;
class WXDDSurfaceDesc;
class WXDDSurface;
class WXDDFlipSurface;
class WXD3Device;

///	DirectDraw  Ԃl`FbNAG[΃G[bZ[W\B
class WXDDError:public WXDXError{
	public:
	virtual bool Check(DWORD n, const char* msg, const char* fn=NULL, int ln=0);
	static bool DDErrorToString(char*& err, char*& desc, HRESULT error);
	static bool D3DErrorToString(char*& err, char*& desc, HRESULT error);
};

class WXDDraws;

///	This class represents display card. fBXvCJ[h\NXB

class WXDDraw {
	friend WXDDraws;
protected:
	HWND hWnd;
	bool bFullscreen;
	WINDOWPLACEMENT wplaceOld;
	bool CreatePalette();
	void ReleasePalette();
	void SetClipper();
	void GetDisplayMode();
	WXDDraws* pWXDDraws;
public:
	///	direct draw interfaces
	IDirectDraw* pDDraw;
	IDirectDraw2* pDDraw2;
#if DIRECTDRAW_VERSION >= 0x0700
	IDirectDraw7* pDDraw7;
	typedef IDirectDraw7 IDirectDrawC;
	IDirectDrawC*& PDDraw(){return pDDraw7;}
#else
	typedef IDirectDraw2 IDirectDrawC;
	IDirectDrawC*& PDDraw(){return pDDraw2;}
#endif
	IDirectDrawPalette* pPalette;
	IDirectDrawClipper* pClipper;
	///	direct 3d interface
#if DIRECTDRAW_VERSION >= 0x0700
	IDirect3D2* pD3D;
	IDirect3D7* pD3D7;
	typedef IDirect3D7 IDirect3DC;
	IDirect3DC*& PWXD3D(){return pD3D7;}
#elif DIRECTDRAW_VERSION >= 0x0500
	IDirect3D2* pD3D;
	typedef IDirect3D2 IDirect3DC;
	IDirect3DC*& PWXD3D(){return pD3D;}
#else
	IDirect3D* pD3D;
	typedef IDirect3D IDirect3DC;
	IDirect3DC* PWXD3D(){return pD3D;}
#endif
	///	ddraw device driver infomation
	///	foCXhCo̖O
	std::string name;
	//	foCXhCo̐
	std::string desc;
	GUID* pGuid;
	WXDDSurfaceDesc displayMode;
	//	etc
	///	\ʂ̃obt@
	WXDDSurface surfPrimary;
	///	tXN[̃fBXvC[h
	WXDDDisplayModes modes;
	///	pDDraẘJOɊJIuWFNg
	std::vector<WXUnknown> objs;

	///
	WXDDraw();
	///
	WXDDraw(const WXDDraw& dd);
	~WXDDraw();
	///	쐬(2D̂)
	bool Create();
	///	쐬(3D܂)
	bool Create3D();
	///	J(~WXDDrawĂ)
	void Release();
	///	device window ƂĎg window
	HWND HWnd(){return hWnd;}
	/**	device window ̐ݒ
		ʏ͐ݒ肵Ȃł悢Bݒ肵ȂΎIɃEBhEB
		focus windowƓEBhE̎qEBhEݒ肷B */	
	void HWnd(HWND full);

	///	tXN[[hɂ
	bool Fullscreen(const WXDDDisplayMode& m);
	///	tXN[[hɂ
	bool Fullscreen(int w=640, int h=480, int bitPerPixel=16,int refresh=0);
	///	EBhE[hɖ߂
	bool Window();
	///	tXN[[hȂ true ԂB
	bool IsFullscreen(){ return bFullscreen; }
	WXDDraws* PWXDDraws(){ return pWXDDraws; }
	static DWORD BPPToDDBD(int bpp);
	static DWORD FindBPP(DWORD ddbd, int bpp);

	static WXDDError& Error();
	friend class WXDDSurface;
	friend class WXDDFrontSurface;
	friend class WXDDFlipSurface;
	friend class WXD3Device;
};
class AA{};

/**	PCɂȂĂ邷ׂẴfBXv[J[h\NX.
	DirectDrawgp邽߂ɁA1AvP[V1
	CX^XB
*/
class WXDDraws: protected std::vector<WXDDraw>
	{
	friend WXDDraw;
	protected:
	static WXDDraws* last;
	WXDDraws* lastOld;
	WXDDraw* primary;
	HWND hWnd;
	bool Create();
	static BOOL WINAPI DDEnumCallback(GUID* pGUID, char* pDesc, char* pName, void* pContext);
#if DIRECTDRAW_VERSION < 0x700
	static BOOL WINAPI DDEnumCallbackEx(GUID* pGUID, char* pDesc, char* pName, void* pContext, HANDLE hm);
#else
	static BOOL WINAPI DDEnumCallbackEx(GUID* pGUID, char* pDesc, char* pName, void* pContext, HMONITOR hm);
#endif

	public:
    //  Thread ̔rp
#ifdef MULTITHREAD
	static CCriticalSection& CriticalSection();
#endif
	WXDDraws();
	~WXDDraws();
	///	focus window ƂĎgWindowB
	HWND HWnd(){return hWnd;}
	/**	focus window ƂĎgWindow̐ݒB
		AvP[ṼCEBhEpB
		CEBhEȊOnƁAeEBhEǂăCEBhEB
		ݒ肵ȂƃtXN[ɂłȂB
		DirectSoundȂǑDirectXɓnWindowƓEBhEnƁB */
	void HWnd(HWND wnd);
	///	fBXvCJ[hւ̃ANZX
	///	fXNgbvŜ\B
	WXDDraw& Primary();
	///	iԖڂ̃fBXvCJ[hA0̓fBXNgbvŜ\B
	WXDDraw&	DDraw(int i){ return begin()[i]; }
	///	iԖڂ̃fBXvCJ[hA0̓fBXNgbvŜ\B
	WXDDraw& operator [](int i){	return begin()[i]; }
	///	fBXvCJ[h̐(+1)
	int Size() const { return size(); }
	///	ŌɍWXDDraws (2ȏ̂͗ǂȂ)
	static WXDDraws* GetLastCreate();
	};
}	//	namespace Spr

#endif
